import processing.sound.*;

AudioIn input;
Amplitude rms;

int scale=1;

PImage img;

ArrayList myPixels;
ArrayList myFishes;


void setup() {

  size(500, 500);

  input = new AudioIn(this, 0);

  // start the Audio Input
  input.start();

  // create a new Amplitude analyzer
  rms = new Amplitude(this);

  // Patch the input to an volume analyzer
  rms.input(input);

  img = loadImage("hello.png");

  myFishes = new ArrayList();
  myPixels = new ArrayList();

  for (int i=0; i<1000; i++) {

    myFishes.add(new Fish());
    
  }
  
  for (int i=0; i<img.width; i++) {
    
    for (int j=0; j<img.height; j++) {
      
      color c = img.get(i,j);
      if (red(c) == 255) {
        myPixels.add(new WhitePixels(i,j));
      }
      
    }
  }
  
}


void draw() {

  input.amp(map(mouseY, 0, height, 0.0, 1.0));
  scale=int(map(rms.analyze(), 0, 0.5, 1, 350));

  fill(0, 100);
  rect(0, 0, width, height);

  for (int i=myFishes.size()-1; i>0; i--) {

    Fish temp = (Fish) myFishes.get(i);
    temp.updateFish();
    temp.drawFish();
  }
}

void mousePressed() {

  for (int i=myFishes.size()-1; i>0; i--) {

    Fish temp = (Fish) myFishes.get(i);
    temp.targetX = mouseX;
    temp.targetY = mouseY;
    temp.targetC = color(255,0,0);
    
  }
  
}

void mouseReleased() {

  for (int i=myFishes.size()-1; i>0; i--) {

    Fish temp = (Fish) myFishes.get(i);
    temp.targetX = random(width);
    temp.targetY = random(height);
    temp.targetC = color(255,0,0);
  }
}


void keyPressed() {

  for (int i=myFishes.size()-1; i>0; i--) {

    Fish temp = (Fish) myFishes.get(i);
    
    WhitePixels r = (WhitePixels) myPixels.get(int(random(myPixels.size()-1)));
    
    int rx = r.x;
    int ry = r.y;
    temp.targetX = rx;
    temp.targetY = ry;
    temp.changeColor = true;
    if (temp.changeColor) {
      temp.targetC = color(0,0,255);
 
    }
    
  }
  
}

void keyReleased() {
  
  
  
}